/*
     Verify that this user/password is valid per a database LDAP server
     Return 1 if verified, 0 otherwise.
     
     Format of connection string (look like internet URL):

       ldap://LDAP-hostname
     
     -------------------------------------------------------
     patrick.harpes@tudor.lu            http://www.santel.lu
                                        http://www.tudor.lu
     


     Dependencies: You need to get the OpenLDAP libraries
                   from http://www.openldap.org
 
      License: tac_ldap is free software; you can redistribute it
               and/or modify it under the terms of the GNU General Public License
               as published by the Free Software Foundation; either version 2,
               or (at your option) any later version.
 */ 

/*#if defined(LDAP)*/
#include <stdio.h>
#include <string.h>
#include <lber.h>
#include <ldap.h>
#include <ldap_cdefs.h>

#include "tac_plus.h"
#include "ldap.h"


int
ldap_verify(user, users_passwd, str_conn)
char *user, *users_passwd;      /* Username and gived password   */
char *str_conn;                 /* String connection to database */
{



  char *ldapServer;
  char l_err[200];
  LDAP *ld;
  int err;

  ldapServer=strstr(str_conn, "://");
  ldapServer=ldapServer+3;
  report(LOG_INFO, "In verify_ldap : Before ldap_init : ldapserver = %s", ldapServer);


  if( (ld = ldap_init(ldapServer, LDAP_PORT)) == NULL)
    {
      fprintf(stderr, "\nUnable to connect to LDAP server:%s port:%d\n",
	      ldapServer, LDAP_PORT);
      return 1;
    }
  
  /*report(LOG_INFO, "In verify_ldap : After ldap_init : ldapserver = %s, user=%s, passwd=%s", ldapServer,user,users_passwd);*/
  err=ldap_simple_bind_s(ld, user, users_passwd);
  sprintf(l_err,"%i",err);
  report(LOG_INFO, "Ldap_verify : LDAP ERROR %s",l_err);
  if(err != LDAP_SUCCESS)
    {
      printf("Error while bind : %0x %s\n",err, ldap_err2string(err));
      fprintf(stderr, "\nUnable to bind\n");
      return 1;
    }         
  else
    {
      /* Success */
      return 0;
    }
}

/*#endif*/ /* LDAP */
